//#include <locale.h>
//#include <stdio.h>
//#include <stdlib.h>
#include <string.h>
//#include <sys/time.h>

#include "gtk/gtk.h"

static void doSetzenFileName (char *pinfileName)
	{
		GtkWidget *lfilechooserdialog;
		char *lFileName;

		lfilechooserdialog = gtk_file_chooser_dialog_new ("Ein File wählen ...", NULL, GTK_FILE_CHOOSER_ACTION_OPEN, "_Abbrechen", GTK_RESPONSE_CANCEL, "_Weiter", GTK_RESPONSE_ACCEPT, NULL);
		gtk_file_chooser_set_select_multiple ((GtkFileChooser *)lfilechooserdialog, FALSE);

		if (gtk_dialog_run (GTK_DIALOG (lfilechooserdialog)) == GTK_RESPONSE_ACCEPT)
			{
				lFileName = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (lfilechooserdialog));
				strcpy (pinfileName, lFileName);
				g_free (lFileName);
			}

		gtk_widget_destroy (lfilechooserdialog);
	}

/************************************************************************************
OrderEntryWindow
************************************************************************************/
GtkWidget *OrderEntryWindow;
GtkStyleContext *OrderEntryWindowStyleContext;
GtkCssProvider *OrderEntryWindowCssProvider;

GtkWidget *OrderEntryWindowFixedLayout;

GtkWidget *Label_OrderEntryWindowUeberschrift;
GtkStyleContext *Label_OrderEntryWindowUeberschriftStyleContext;
GtkCssProvider *Label_OrderEntryWindowUeberschriftCssProvider;

GtkWidget *Label_OrderEntryWimdowZeichenAuszaehlen;

GtkWidget *Image_OrderEntryWindowAbbrechen;
GtkWidget *PBut_OrderEntryWindowAbbrechen;

GtkWidget *Label_OrderEntryWindowMessage;
GtkStyleContext *Label_OrderEntryWindowMessageStyleContext;
GtkCssProvider *Label_OrderEntryWindowMessageCssProvider;

unsigned long OrderEntryWindowKeyPressHandlerId;

static void OrderEntryWindowdoit (GtkWidget *pwidget, GdkEvent *pevent, gpointer pdata)
	{
		if (pwidget == PBut_OrderEntryWindowAbbrechen)
			{
				gtk_widget_destroy (OrderEntryWindow);
				gtk_main_quit ();
				return;
			}
	}

static void OrderEntryWindowdoenter (GtkWidget *pwidget, GdkEvent *pevent, gpointer pdata)
	{
		if (pwidget == PBut_OrderEntryWindowAbbrechen)
			{
				gtk_image_set_from_file (GTK_IMAGE (Image_OrderEntryWindowAbbrechen), "./__png's/abbrechenchosen.png");
				return;
			}
	}
static void OrderEntryWindowdoleave (GtkWidget *pwidget, GdkEvent *pevent, gpointer pdata)
	{
		if (pwidget == PBut_OrderEntryWindowAbbrechen)
			{
				gtk_image_set_from_file (GTK_IMAGE (Image_OrderEntryWindowAbbrechen), "./__png's/abbrechennotchosen.png");
				return;
			}
	}
static int OrderEntrywindowdokeypressevent (GtkWidget *pwidget, GdkEventKey *pkeyevent, gpointer pdata)
	{
		int lreturnwert = FALSE;

		switch (pkeyevent->keyval)
			{
				case 65293 : // Return
				case 65421 : // Enter
					lreturnwert = TRUE;
					break;
			}

		return lreturnwert;
	}

int main (int argc, char **argv)
	{
		char linputfilename[1005] = "";

		gtk_init (&argc, &argv);

		g_object_set (gtk_settings_get_default (), "gtk-font-name", "Helvetica 12", NULL);

		OrderEntryWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
		g_signal_connect (OrderEntryWindow, "destroy", G_CALLBACK (gtk_main_quit), NULL);
		gtk_window_move (GTK_WINDOW (OrderEntryWindow), 50, 50);
		gtk_window_resize (GTK_WINDOW(OrderEntryWindow), 900, 375);
		gtk_window_set_decorated (GTK_WINDOW (OrderEntryWindow), FALSE);

		OrderEntryWindowStyleContext = gtk_widget_get_style_context (OrderEntryWindow);
		OrderEntryWindowCssProvider = gtk_css_provider_new ();
		gtk_css_provider_load_from_data (GTK_CSS_PROVIDER (OrderEntryWindowCssProvider),
			"GtkWindow {background-color: rgb(210, 210, 210); border-top: 3px ridge #555555; border-left: 3px ridge #555555; border-bottom: 3px ridge #999999; border-right: 3px ridge #999999;}", -1, NULL);
		gtk_style_context_add_provider (OrderEntryWindowStyleContext, GTK_STYLE_PROVIDER (OrderEntryWindowCssProvider), GTK_STYLE_PROVIDER_PRIORITY_USER);
		g_object_unref (OrderEntryWindowCssProvider);

		OrderEntryWindowKeyPressHandlerId = g_signal_connect (G_OBJECT (OrderEntryWindow), "key_press_event", G_CALLBACK (OrderEntrywindowdokeypressevent), NULL);

		OrderEntryWindowFixedLayout = gtk_fixed_new ();

		Label_OrderEntryWindowUeberschrift = gtk_label_new ("Example");
		gtk_widget_set_size_request (Label_OrderEntryWindowUeberschrift, 880, 0);

		Label_OrderEntryWimdowZeichenAuszaehlen = gtk_label_new ("Label : ");
		gtk_fixed_put (GTK_FIXED (OrderEntryWindowFixedLayout), Label_OrderEntryWimdowZeichenAuszaehlen, 300-104, 75);

		gtk_fixed_put (GTK_FIXED (OrderEntryWindowFixedLayout), Label_OrderEntryWindowUeberschrift, 10, 30);

		Image_OrderEntryWindowAbbrechen = gtk_image_new ();
		gtk_image_set_from_file (GTK_IMAGE (Image_OrderEntryWindowAbbrechen), "./__png's/abbrechennotchosen.png");
		PBut_OrderEntryWindowAbbrechen = gtk_event_box_new ();
		gtk_container_add (GTK_CONTAINER (PBut_OrderEntryWindowAbbrechen), Image_OrderEntryWindowAbbrechen);
		gtk_fixed_put (GTK_FIXED(OrderEntryWindowFixedLayout), PBut_OrderEntryWindowAbbrechen, 150, 300);
		g_signal_connect (G_OBJECT (PBut_OrderEntryWindowAbbrechen), "button-press-event", G_CALLBACK (OrderEntryWindowdoit), NULL);
	  	g_signal_connect (G_OBJECT (PBut_OrderEntryWindowAbbrechen), "enter-notify-event", G_CALLBACK (OrderEntryWindowdoenter), NULL);
	  	g_signal_connect (G_OBJECT (PBut_OrderEntryWindowAbbrechen), "leave-notify-event", G_CALLBACK (OrderEntryWindowdoleave), NULL);

		gtk_container_add (GTK_CONTAINER(OrderEntryWindow), OrderEntryWindowFixedLayout);

		gtk_widget_show_all (OrderEntryWindow);

		gtk_main ();

		strcpy (linputfilename, "");
		doSetzenFileName (linputfilename);
		if (strlen (linputfilename) == 0)
			return -1;

		return 0;
	}
